/**
 * Fuse.js v5.2.1 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
const t=t=>Array.isArray?Array.isArray(t):"[object Array]"===Object.prototype.toString.call(t),e=t=>"string"==typeof t,s=t=>"number"==typeof t,n=t=>null!=t;var i={isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:(t,e)=>t.score-e.score,includeMatches:!1,findAllMatches:!1,minMatchCharLength:1,location:0,threshold:.6,distance:100,...{useExtendedSearch:!1,getFn:function(i,h){let r=[],o=!1;const c=(i,h)=>{if(h){const l=h.indexOf(".");let a=h,u=null;-1!==l&&(a=h.slice(0,l),u=h.slice(l+1));const d=i[a];if(n(d))if(u||!e(d)&&!s(d))if(t(d)){o=!0;for(let t=0,e=d.length;t<e;t+=1)c(d[t],u)}else u&&c(d,u);else r.push((t=>null==t?"":(t=>{if("string"==typeof t)return t;let e=t+"";return"0"==e&&1/t==-1/0?"-0":e})(t))(d))}else r.push(i)};return c(i,h),o?r:r[0]}}};function h(t,{errors:e=0,currentLocation:s=0,expectedLocation:n=0,distance:h=i.distance}={}){const r=e/t.length,o=Math.abs(n-s);return h?r+o/h:o?1:r}function r(t,e,s,{location:n=i.location,distance:r=i.distance,threshold:o=i.threshold,findAllMatches:c=i.findAllMatches,minMatchCharLength:l=i.minMatchCharLength,includeMatches:a=i.includeMatches}={}){if(e.length>32)throw new Error("Pattern length exceeds max of 32.");const u=e.length,d=t.length,f=Math.max(0,Math.min(n,d));let g=o,p=f;const y=[];if(a)for(let t=0;t<d;t+=1)y[t]=0;let m;for(;(m=t.indexOf(e,p))>-1;){let t=h(e,{currentLocation:m,expectedLocation:f,distance:r});if(g=Math.min(t,g),p=m+u,a){let t=0;for(;t<u;)y[m+t]=1,t+=1}}p=-1;let M=[],k=1,x=u+d;const _=1<<(u<=31?u-1:30);for(let n=0;n<u;n+=1){let i=0,o=x;for(;i<o;){h(e,{errors:n,currentLocation:f+o,expectedLocation:f,distance:r})<=g?i=o:x=o,o=Math.floor((x-i)/2+i)}x=o;let l=Math.max(1,f-o+1),m=c?d:Math.min(f+o,d)+u,I=Array(m+2);I[m+1]=(1<<n)-1;for(let i=m;i>=l;i-=1){let o=i-1,c=s[t.charAt(o)];if(c&&a&&(y[o]=1),I[i]=(I[i+1]<<1|1)&c,0!==n&&(I[i]|=(M[i+1]|M[i])<<1|1|M[i+1]),I[i]&_&&(k=h(e,{errors:n,currentLocation:o,expectedLocation:f,distance:r}),k<=g)){if(g=k,p=o,p<=f)break;l=Math.max(1,2*f-p)}}if(h(e,{errors:n+1,currentLocation:f,expectedLocation:f,distance:r})>g)break;M=I}let I={isMatch:p>=0,score:k||.001};return a&&(I.matchedIndices=function(t=[],e=i.minMatchCharLength){let s=[],n=-1,h=-1,r=0;for(let i=t.length;r<i;r+=1){let i=t[r];i&&-1===n?n=r:i||-1===n||(h=r-1,h-n+1>=e&&s.push([n,h]),n=-1)}return t[r-1]&&r-n>=e&&s.push([n,r-1]),s}(y,l)),I}function o(t){let e={},s=t.length;for(let n=0;n<s;n+=1)e[t.charAt(n)]=0;for(let n=0;n<s;n+=1)e[t.charAt(n)]|=1<<s-n-1;return e}class c{constructor(t,{location:e=i.location,threshold:s=i.threshold,distance:n=i.distance,includeMatches:h=i.includeMatches,findAllMatches:r=i.findAllMatches,minMatchCharLength:c=i.minMatchCharLength,isCaseSensitive:l=i.isCaseSensitive}={}){this.options={location:e,threshold:s,distance:n,includeMatches:h,findAllMatches:r,minMatchCharLength:c,isCaseSensitive:l},this.pattern=l?t:t.toLowerCase(),this.chunks=[];let a=0;for(;a<this.pattern.length;){let t=this.pattern.substring(a,a+32);this.chunks.push({pattern:t,alphabet:o(t)}),a+=32}}searchIn(t){let e=t.$;return this.searchInString(e)}searchInString(t){const{isCaseSensitive:e,includeMatches:s}=this.options;if(e||(t=t.toLowerCase()),this.pattern===t){let e={isMatch:!0,score:0};return s&&(e.matchedIndices=[[0,t.length-1]]),e}const{location:n,distance:i,threshold:h,findAllMatches:o,minMatchCharLength:c}=this.options;let l=[],a=0,u=!1;for(let e=0,d=this.chunks.length;e<d;e+=1){let{pattern:d,alphabet:f}=this.chunks[e],g=r(t,d,f,{location:n+32*e,distance:i,threshold:h,findAllMatches:o,minMatchCharLength:c,includeMatches:s});const{isMatch:p,score:y,matchedIndices:m}=g;p&&(u=!0),a+=y,p&&m&&(l=[...l,...m])}let d={isMatch:u,score:u?a/this.chunks.length:1};return u&&s&&(d.matchedIndices=l),d}}const l=/[^ ]+/g;function a(s,h,{getFn:r=i.getFn}={}){let o=[];if(e(h[0]))for(let t=0,e=h.length;t<e;t+=1){const e=h[t];if(n(e)){let s={$:e,idx:t,t:e.match(l).length};o.push(s)}}else{const i=s.length;for(let c=0,a=h.length;c<a;c+=1){let a=h[c],u={idx:c,$:{}};for(let h=0;h<i;h+=1){let i=s[h],o=r(a,i);if(n(o))if(t(o)){let s=[];const h=[{arrayIndex:-1,value:o}];for(;h.length;){const{arrayIndex:i,value:r}=h.pop();if(n(r))if(e(r)){let t={$:r,idx:i,t:r.match(l).length};s.push(t)}else if(t(r))for(let t=0,e=r.length;t<e;t+=1)h.push({arrayIndex:t,value:r[t]})}u.$[i]=s}else{let t={$:o,t:o.match(l).length};u.$[i]=t}}o.push(u)}}return o}class u{constructor(t){if(this._keys={},this._keyNames=[],this._length=t.length,t.length&&e(t[0]))for(let e=0;e<this._length;e+=1){const s=t[e];this._keys[s]={weight:1},this._keyNames.push(s)}else{let e=0;for(let s=0;s<this._length;s+=1){const n=t[s];if(!Object.prototype.hasOwnProperty.call(n,"name"))throw new Error('Missing "name" property in key object');const i=n.name;if(this._keyNames.push(i),!Object.prototype.hasOwnProperty.call(n,"weight"))throw new Error('Missing "weight" property in key object');const h=n.weight;if(h<=0||h>=1)throw new Error('"weight" property in key must be in the range of (0, 1)');this._keys[i]={weight:h},e+=h}for(let t=0;t<this._length;t+=1){const s=this._keyNames[t],n=this._keys[s].weight;this._keys[s].weight=n/e}}}get(t,e){return this._keys[t]?this._keys[t][e]:-1}keys(){return this._keyNames}count(){return this._length}toJSON(){return JSON.stringify(this._keys)}}function d(t,e){const s=t.matches;if(e.matches=[],n(s))for(let t=0,i=s.length;t<i;t+=1){let i=s[t];if(!n(i.indices)||0===i.indices.length)continue;let h={indices:i.indices,value:i.value};i.key&&(h.key=i.key),i.idx>-1&&(h.refIndex=i.idx),e.matches.push(h)}}function f(t,e){e.score=t.score}const g=[];class p{constructor(t,e={},s=null){this.options={...i,...e},this._processKeys(this.options.keys),this.setCollection(t,s)}setCollection(t,s=null){this.list=t,this.listIsStringArray=e(t[0]),s?this.setIndex(s):this.setIndex(this._createIndex())}setIndex(t){this._indexedList=t}_processKeys(t){this._keyStore=new u(t)}_createIndex(){return a(this._keyStore.keys(),this.list,{getFn:this.options.getFn})}search(t,e={limit:!1}){if(!(t=t.trim()).length)return[];const{shouldSort:n}=this.options;let i=null;for(let e=0,s=g.length;e<s;e+=1){let s=g[e];if(s.condition(t,this.options)){i=new s(t,this.options);break}}i||(i=new c(t,this.options));let h=this._searchUsing(i);return this._computeScore(h),n&&this._sort(h),e.limit&&s(e.limit)&&(h=h.slice(0,e.limit)),this._format(h)}_searchUsing(e){const s=this._indexedList,i=[],{includeMatches:h}=this.options;if(this.listIsStringArray)for(let t=0,r=s.length;t<r;t+=1){let r=s[t],{$:o,idx:c,t:l}=r;if(!n(o))continue;let a=e.searchIn(r);const{isMatch:u,score:d}=a;if(!u)continue;let f={score:d,value:o,t:l};h&&(f.indices=a.matchedIndices),i.push({item:o,idx:c,matches:[f]})}else{const r=this._keyStore.keys(),o=this._keyStore.count();for(let c=0,l=s.length;c<l;c+=1){let{$:l,idx:a}=s[c];if(!n(l))continue;let u=[];for(let s=0;s<o;s+=1){let i=r[s],o=l[i];if(n(o))if(t(o))for(let t=0,s=o.length;t<s;t+=1){let s=o[t];const{$:r,idx:c,t:l}=s;if(!n(r))continue;let a=e.searchIn(s);const{isMatch:d,score:f}=a;if(!d)continue;let g={score:f,key:i,value:r,idx:c,t:l};h&&(g.indices=a.matchedIndices),u.push(g)}else{const{$:t,t:s}=o;let n=e.searchIn(o);const{isMatch:r,score:c}=n;if(!r)continue;let l={score:c,key:i,value:t,t:s};h&&(l.indices=n.matchedIndices),u.push(l)}}u.length&&i.push({idx:a,item:l,matches:u})}}return i}_computeScore(t){const e=t.length;for(let s=0;s<e;s+=1){const e=t[s],n=e.matches,i=n.length;let h=1;for(let t=0;t<i;t+=1){const e=n[t],{key:s,t:i}=e,r=this._keyStore.get(s,"weight"),o=r>-1?r:1,c=0===e.score&&r>-1?Number.EPSILON:e.score,l=1/Math.sqrt(i);h*=Math.pow(c,o*l)}e.score=h}}_sort(t){t.sort(this.options.sortFn)}_format(t){const e=[],{includeMatches:s,includeScore:n}=this.options;let i=[];s&&i.push(d),n&&i.push(f);for(let s=0,n=t.length;s<n;s+=1){const n=t[s],{idx:h}=n,r={item:this.list[h],refIndex:h};if(i.length)for(let t=0,e=i.length;t<e;t+=1)i[t](n,r);e.push(r)}return e}}p.version="5.2.1",p.createIndex=a,p.config=i;export default p;