/**
 * Fuse.js v5.2.1 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
const t=t=>Array.isArray?Array.isArray(t):"[object Array]"===Object.prototype.toString.call(t),e=t=>"string"==typeof t,s=t=>"number"==typeof t,n=t=>null!=t;var i={isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:(t,e)=>t.score-e.score,includeMatches:!1,findAllMatches:!1,minMatchCharLength:1,location:0,threshold:.6,distance:100,...{useExtendedSearch:!1,getFn:function(i,r){let c=[],h=!1;const o=(i,r)=>{if(r){const a=r.indexOf(".");let l=r,u=null;-1!==a&&(l=r.slice(0,a),u=r.slice(a+1));const d=i[l];if(n(d))if(u||!e(d)&&!s(d))if(t(d)){h=!0;for(let t=0,e=d.length;t<e;t+=1)o(d[t],u)}else u&&o(d,u);else c.push((t=>null==t?"":(t=>{if("string"==typeof t)return t;let e=t+"";return"0"==e&&1/t==-1/0?"-0":e})(t))(d))}else c.push(i)};return o(i,r),h?c:c[0]}}};function r(t,{errors:e=0,currentLocation:s=0,expectedLocation:n=0,distance:r=i.distance}={}){const c=e/t.length,h=Math.abs(n-s);return r?c+h/r:h?1:c}function c(t,e,s,{location:n=i.location,distance:c=i.distance,threshold:h=i.threshold,findAllMatches:o=i.findAllMatches,minMatchCharLength:a=i.minMatchCharLength,includeMatches:l=i.includeMatches}={}){if(e.length>32)throw new Error("Pattern length exceeds max of 32.");const u=e.length,d=t.length,g=Math.max(0,Math.min(n,d));let f=h,p=g;const m=[];if(l)for(let t=0;t<d;t+=1)m[t]=0;let M;for(;(M=t.indexOf(e,p))>-1;){let t=r(e,{currentLocation:M,expectedLocation:g,distance:c});if(f=Math.min(t,f),p=M+u,l){let t=0;for(;t<u;)m[M+t]=1,t+=1}}p=-1;let x=[],y=1,k=u+d;const S=1<<(u<=31?u-1:30);for(let n=0;n<u;n+=1){let i=0,h=k;for(;i<h;){r(e,{errors:n,currentLocation:g+h,expectedLocation:g,distance:c})<=f?i=h:k=h,h=Math.floor((k-i)/2+i)}k=h;let a=Math.max(1,g-h+1),M=o?d:Math.min(g+h,d)+u,_=Array(M+2);_[M+1]=(1<<n)-1;for(let i=M;i>=a;i-=1){let h=i-1,o=s[t.charAt(h)];if(o&&l&&(m[h]=1),_[i]=(_[i+1]<<1|1)&o,0!==n&&(_[i]|=(x[i+1]|x[i])<<1|1|x[i+1]),_[i]&S&&(y=r(e,{errors:n,currentLocation:h,expectedLocation:g,distance:c}),y<=f)){if(f=y,p=h,p<=g)break;a=Math.max(1,2*g-p)}}if(r(e,{errors:n+1,currentLocation:g,expectedLocation:g,distance:c})>f)break;x=_}let _={isMatch:p>=0,score:y||.001};return l&&(_.matchedIndices=function(t=[],e=i.minMatchCharLength){let s=[],n=-1,r=-1,c=0;for(let i=t.length;c<i;c+=1){let i=t[c];i&&-1===n?n=c:i||-1===n||(r=c-1,r-n+1>=e&&s.push([n,r]),n=-1)}return t[c-1]&&c-n>=e&&s.push([n,c-1]),s}(m,a)),_}function h(t){let e={},s=t.length;for(let n=0;n<s;n+=1)e[t.charAt(n)]=0;for(let n=0;n<s;n+=1)e[t.charAt(n)]|=1<<s-n-1;return e}class o{constructor(t,{location:e=i.location,threshold:s=i.threshold,distance:n=i.distance,includeMatches:r=i.includeMatches,findAllMatches:c=i.findAllMatches,minMatchCharLength:o=i.minMatchCharLength,isCaseSensitive:a=i.isCaseSensitive}={}){this.options={location:e,threshold:s,distance:n,includeMatches:r,findAllMatches:c,minMatchCharLength:o,isCaseSensitive:a},this.pattern=a?t:t.toLowerCase(),this.chunks=[];let l=0;for(;l<this.pattern.length;){let t=this.pattern.substring(l,l+32);this.chunks.push({pattern:t,alphabet:h(t)}),l+=32}}searchIn(t){let e=t.$;return this.searchInString(e)}searchInString(t){const{isCaseSensitive:e,includeMatches:s}=this.options;if(e||(t=t.toLowerCase()),this.pattern===t){let e={isMatch:!0,score:0};return s&&(e.matchedIndices=[[0,t.length-1]]),e}const{location:n,distance:i,threshold:r,findAllMatches:h,minMatchCharLength:o}=this.options;let a=[],l=0,u=!1;for(let e=0,d=this.chunks.length;e<d;e+=1){let{pattern:d,alphabet:g}=this.chunks[e],f=c(t,d,g,{location:n+32*e,distance:i,threshold:r,findAllMatches:h,minMatchCharLength:o,includeMatches:s});const{isMatch:p,score:m,matchedIndices:M}=f;p&&(u=!0),l+=m,p&&M&&(a=[...a,...M])}let d={isMatch:u,score:u?l/this.chunks.length:1};return u&&s&&(d.matchedIndices=a),d}}class a{constructor(t){this.pattern=t}static isMultiMatch(t){return l(t,this.multiRegex)}static isSingleMatch(t){return l(t,this.singleRegex)}search(){}}function l(t,e){const s=t.match(e);return s?s[1]:null}class u extends a{constructor(t){super(t)}static get type(){return"exact"}static get multiRegex(){return/^'"(.*)"$/}static get singleRegex(){return/^'(.*)$/}search(t){let e,s=0;const n=[],i=this.pattern.length;for(;(e=t.indexOf(this.pattern,s))>-1;)s=e+i,n.push([e,s-1]);const r=!!n.length;return{isMatch:r,score:r?1:0,matchedIndices:n}}}class d extends a{constructor(t,{location:e=i.location,threshold:s=i.threshold,distance:n=i.distance,includeMatches:r=i.includeMatches,findAllMatches:c=i.findAllMatches,minMatchCharLength:h=i.minMatchCharLength,isCaseSensitive:a=i.isCaseSensitive}={}){super(t),this._bitapSearch=new o(t,{location:e,threshold:s,distance:n,includeMatches:r,findAllMatches:c,minMatchCharLength:h,isCaseSensitive:a})}static get type(){return"fuzzy"}static get multiRegex(){return/^"(.*)"$/}static get singleRegex(){return/^(.*)$/}search(t){return this._bitapSearch.searchInString(t)}}const g=[u,class extends a{constructor(t){super(t)}static get type(){return"prefix-exact"}static get multiRegex(){return/^\^"(.*)"$/}static get singleRegex(){return/^\^(.*)$/}search(t){const e=t.startsWith(this.pattern);return{isMatch:e,score:e?0:1,matchedIndices:[0,this.pattern.length-1]}}},class extends a{constructor(t){super(t)}static get type(){return"inverse-prefix-exact"}static get multiRegex(){return/^!\^"(.*)"$/}static get singleRegex(){return/^!\^(.*)$/}search(t){const e=!t.startsWith(this.pattern);return{isMatch:e,score:e?0:1,matchedIndices:[0,t.length-1]}}},class extends a{constructor(t){super(t)}static get type(){return"inverse-suffix-exact"}static get multiRegex(){return/^!"(.*)"\$$/}static get singleRegex(){return/^!(.*)\$$/}search(t){const e=!t.endsWith(this.pattern);return{isMatch:e,score:e?0:1,matchedIndices:[0,t.length-1]}}},class extends a{constructor(t){super(t)}static get type(){return"suffix-exact"}static get multiRegex(){return/^"(.*)"\$$/}static get singleRegex(){return/^(.*)\$$/}search(t){const e=t.endsWith(this.pattern);return{isMatch:e,score:e?0:1,matchedIndices:[t.length-this.pattern.length,t.length-1]}}},class extends a{constructor(t){super(t)}static get type(){return"inverse-exact"}static get multiRegex(){return/^!"(.*)"$/}static get singleRegex(){return/^!(.*)$/}search(t){const e=-1===t.indexOf(this.pattern);return{isMatch:e,score:e?0:1,matchedIndices:[0,t.length-1]}}},d],f=g.length,p=/ +(?=([^\"]*\"[^\"]*\")*[^\"]*$)/;const m=new Set([d.type,u.type]);const M=/[^ ]+/g;function x(s,r,{getFn:c=i.getFn}={}){let h=[];if(e(r[0]))for(let t=0,e=r.length;t<e;t+=1){const e=r[t];if(n(e)){let s={$:e,idx:t,t:e.match(M).length};h.push(s)}}else{const i=s.length;for(let o=0,a=r.length;o<a;o+=1){let a=r[o],l={idx:o,$:{}};for(let r=0;r<i;r+=1){let i=s[r],h=c(a,i);if(n(h))if(t(h)){let s=[];const r=[{arrayIndex:-1,value:h}];for(;r.length;){const{arrayIndex:i,value:c}=r.pop();if(n(c))if(e(c)){let t={$:c,idx:i,t:c.match(M).length};s.push(t)}else if(t(c))for(let t=0,e=c.length;t<e;t+=1)r.push({arrayIndex:t,value:c[t]})}l.$[i]=s}else{let t={$:h,t:h.match(M).length};l.$[i]=t}}h.push(l)}}return h}class y{constructor(t){if(this._keys={},this._keyNames=[],this._length=t.length,t.length&&e(t[0]))for(let e=0;e<this._length;e+=1){const s=t[e];this._keys[s]={weight:1},this._keyNames.push(s)}else{let e=0;for(let s=0;s<this._length;s+=1){const n=t[s];if(!Object.prototype.hasOwnProperty.call(n,"name"))throw new Error('Missing "name" property in key object');const i=n.name;if(this._keyNames.push(i),!Object.prototype.hasOwnProperty.call(n,"weight"))throw new Error('Missing "weight" property in key object');const r=n.weight;if(r<=0||r>=1)throw new Error('"weight" property in key must be in the range of (0, 1)');this._keys[i]={weight:r},e+=r}for(let t=0;t<this._length;t+=1){const s=this._keyNames[t],n=this._keys[s].weight;this._keys[s].weight=n/e}}}get(t,e){return this._keys[t]?this._keys[t][e]:-1}keys(){return this._keyNames}count(){return this._length}toJSON(){return JSON.stringify(this._keys)}}function k(t,e){const s=t.matches;if(e.matches=[],n(s))for(let t=0,i=s.length;t<i;t+=1){let i=s[t];if(!n(i.indices)||0===i.indices.length)continue;let r={indices:i.indices,value:i.value};i.key&&(r.key=i.key),i.idx>-1&&(r.refIndex=i.idx),e.matches.push(r)}}function S(t,e){e.score=t.score}const _=[];class I{constructor(t,e={},s=null){this.options={...i,...e},this._processKeys(this.options.keys),this.setCollection(t,s)}setCollection(t,s=null){this.list=t,this.listIsStringArray=e(t[0]),s?this.setIndex(s):this.setIndex(this._createIndex())}setIndex(t){this._indexedList=t}_processKeys(t){this._keyStore=new y(t)}_createIndex(){return x(this._keyStore.keys(),this.list,{getFn:this.options.getFn})}search(t,e={limit:!1}){if(!(t=t.trim()).length)return[];const{shouldSort:n}=this.options;let i=null;for(let e=0,s=_.length;e<s;e+=1){let s=_[e];if(s.condition(t,this.options)){i=new s(t,this.options);break}}i||(i=new o(t,this.options));let r=this._searchUsing(i);return this._computeScore(r),n&&this._sort(r),e.limit&&s(e.limit)&&(r=r.slice(0,e.limit)),this._format(r)}_searchUsing(e){const s=this._indexedList,i=[],{includeMatches:r}=this.options;if(this.listIsStringArray)for(let t=0,c=s.length;t<c;t+=1){let c=s[t],{$:h,idx:o,t:a}=c;if(!n(h))continue;let l=e.searchIn(c);const{isMatch:u,score:d}=l;if(!u)continue;let g={score:d,value:h,t:a};r&&(g.indices=l.matchedIndices),i.push({item:h,idx:o,matches:[g]})}else{const c=this._keyStore.keys(),h=this._keyStore.count();for(let o=0,a=s.length;o<a;o+=1){let{$:a,idx:l}=s[o];if(!n(a))continue;let u=[];for(let s=0;s<h;s+=1){let i=c[s],h=a[i];if(n(h))if(t(h))for(let t=0,s=h.length;t<s;t+=1){let s=h[t];const{$:c,idx:o,t:a}=s;if(!n(c))continue;let l=e.searchIn(s);const{isMatch:d,score:g}=l;if(!d)continue;let f={score:g,key:i,value:c,idx:o,t:a};r&&(f.indices=l.matchedIndices),u.push(f)}else{const{$:t,t:s}=h;let n=e.searchIn(h);const{isMatch:c,score:o}=n;if(!c)continue;let a={score:o,key:i,value:t,t:s};r&&(a.indices=n.matchedIndices),u.push(a)}}u.length&&i.push({idx:l,item:a,matches:u})}}return i}_computeScore(t){const e=t.length;for(let s=0;s<e;s+=1){const e=t[s],n=e.matches,i=n.length;let r=1;for(let t=0;t<i;t+=1){const e=n[t],{key:s,t:i}=e,c=this._keyStore.get(s,"weight"),h=c>-1?c:1,o=0===e.score&&c>-1?Number.EPSILON:e.score,a=1/Math.sqrt(i);r*=Math.pow(o,h*a)}e.score=r}}_sort(t){t.sort(this.options.sortFn)}_format(t){const e=[],{includeMatches:s,includeScore:n}=this.options;let i=[];s&&i.push(k),n&&i.push(S);for(let s=0,n=t.length;s<n;s+=1){const n=t[s],{idx:r}=n,c={item:this.list[r],refIndex:r};if(i.length)for(let t=0,e=i.length;t<e;t+=1)i[t](n,c);e.push(c)}return e}}!function(...t){_.push(...t)}(class{constructor(t,{isCaseSensitive:e=i.isCaseSensitive,includeMatches:s=i.includeMatches,minMatchCharLength:n=i.minMatchCharLength,findAllMatches:r=i.findAllMatches,location:c=i.location,threshold:h=i.threshold,distance:o=i.distance}={}){this.query=null,this.options={isCaseSensitive:e,includeMatches:s,minMatchCharLength:n,findAllMatches:r,location:c,threshold:h,distance:o},this.pattern=e?t:t.toLowerCase(),this.query=function(t,e={}){return t.split("|").map(t=>{let s=t.trim().split(p).filter(t=>t&&!!t.trim()),n=[];for(let t=0,i=s.length;t<i;t+=1){const i=s[t];let r=!1,c=-1;for(;!r&&++c<f;){const t=g[c];let s=t.isMultiMatch(i);s&&(n.push(new t(s,e)),r=!0)}if(!r)for(c=-1;++c<f;){const t=g[c];let s=t.isSingleMatch(i);if(s){n.push(new t(s,e));break}}}return n})}(this.pattern,this.options)}static condition(t,e){return e.useExtendedSearch}searchIn(t){const e=this.query;if(!e)return{isMatch:!1,score:1};let s=t.$;const{includeMatches:n,isCaseSensitive:i}=this.options;s=i?s:s.toLowerCase();let r=0,c=[],h=0;for(let t=0,i=e.length;t<i;t+=1){const i=e[t];c.length=0,r=0;for(let t=0,e=i.length;t<e;t+=1){const e=i[t],{isMatch:o,matchedIndices:a,score:l}=e.search(s);if(!o){h=0,r=0,c.length=0;break}if(r+=1,h+=l,n){const t=e.constructor.type;m.has(t)?c=[...c,...a]:c.push(a)}}if(r){let t={isMatch:!0,score:h/r};return n&&(t.matchedIndices=c),t}}return{isMatch:!1,score:1}}}),I.version="5.2.1",I.createIndex=x,I.config=i;export default I;